// OpenGLControl.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "OpenGLDialog.h"
#include "OpenGLControl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COpenGLControl

COpenGLControl::COpenGLControl()
{
	dc = NULL;
}

COpenGLControl::~COpenGLControl()
{
	//delete what has been created
	if (dc)
	{
		delete dc;
	}
}


BEGIN_MESSAGE_MAP(COpenGLControl, CWnd)
	//{{AFX_MSG_MAP(COpenGLControl)
	ON_WM_PAINT()
	ON_WM_SIZE()
	ON_WM_CREATE()
	ON_WM_ERASEBKGND()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten COpenGLControl 


void COpenGLControl::InitGL()
{
	glShadeModel(GL_SMOOTH);
	glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
	glClearDepth(1.0f);								
	glDepthFunc(GL_LEQUAL);	
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
	glEnable(GL_DEPTH_TEST);

	glEnable(GL_COLOR_MATERIAL);
}

void COpenGLControl::DrawGLScene()
{
	glClear(GL_COLOR_BUFFER_BIT
		 |  GL_DEPTH_BUFFER_BIT);


	glLoadIdentity();

	//***************************
	// DRAWING CODE
	//***************************

	//do some translations and draw smiley cube..
	glTranslatef(0.0f,0.0f,-5.0f);

	smiley.draw();
}



void COpenGLControl::Create(CRect rect, CWnd *parent)
{
	CString className = AfxRegisterWndClass(
		CS_HREDRAW | CS_VREDRAW | CS_OWNDC,
		NULL,
		(HBRUSH)GetStockObject(BLACK_BRUSH),
		NULL);

	CreateEx(
		0,
		className,
		"OpenGL",
		WS_CHILD | WS_VISIBLE | WS_CLIPSIBLINGS | WS_CLIPCHILDREN,
		rect,
		parent,
		0);
}

void COpenGLControl::OnPaint() 
{
	/****
	 * on every paint message we create a paintstruct
	 * to behave like every other window would do, this
	 * avoids other problems appearing..
	 ***/

	
	PAINTSTRUCT paintInfo;
	CRect windowRect;
	GetWindowRect(&windowRect);

	memset(&paintInfo, 0, sizeof(PAINTSTRUCT));

	paintInfo.hdc = dc->m_hDC;
	paintInfo.fErase = FALSE;
	paintInfo.rcPaint = windowRect;


	//begin paint..
	BeginPaint(&paintInfo);	

	//****** drawing stuff *******///


	/** 
	 * OpenGL section
	 **/

	openGLDevice.makeCurrent();

	//drawing function
	DrawGLScene();
	
	SwapBuffers(dc->m_hDC);

	//end paint and make this a really Windows-like
	//message handler..
	EndPaint(&paintInfo);
}

void COpenGLControl::OnSize(UINT nType, int cx, int cy) 
{
	CWnd::OnSize(nType, cx, cy);
	
	if (cy == 0)								
	{
		cy = 1;						
	}

	glViewport(0,0,cx,cy);	

	glMatrixMode(GL_PROJECTION);						
	glLoadIdentity();						

	gluPerspective(45.0f,float(cx)/float(cy),0.1f,100.0f);

	glMatrixMode(GL_MODELVIEW);						
	glLoadIdentity();
}


int COpenGLControl::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	
	/****
	 * calculate center vector(or point) using
	 * the sizes of this window
	 ****/

	CRect rect;
	GetWindowRect(rect);
	ClientToScreen(rect);
	
	//center is middle of this rect
	SVector vecCenter( rect.CenterPoint().x, rect.CenterPoint().y);	
	
	//create GL device context
	dc = new CClientDC(this);

	openGLDevice.create(dc->m_hDC);

	InitGL();

	//init smiley using the calculated center vector
	//and the texture 
	smiley.create(vecCenter);

	return 0;
}

BOOL COpenGLControl::OnEraseBkgnd(CDC* pDC) 
{
	return FALSE;
}

void COpenGLControl::UpdateMousePosition(int mouseX, int mouseY)
{
	//smiley.updateRotation(mouseX, mouseY);
	CRect windowRect;
	GetWindowRect(&windowRect);


	smiley.updateMousePosition(mouseX, mouseY, windowRect.Width(), windowRect.Height());
}
