// OpenGLDialogDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "OpenGLDialog.h"
#include "OpenGLDialogDlg.h"
#include "AboutDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COpenGLDialogDlg Dialogfeld

COpenGLDialogDlg::COpenGLDialogDlg(CWnd* pParent /*=NULL*/)
	: CDialog(COpenGLDialogDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(COpenGLDialogDlg)
	//}}AFX_DATA_INIT
	// Beachten Sie, dass LoadIcon unter Win32 keinen nachfolgenden DestroyIcon-Aufruf bentigt
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	threadToBeEnded = false;
}

void COpenGLDialogDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COpenGLDialogDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(COpenGLDialogDlg, CDialog)
	//{{AFX_MSG_MAP(COpenGLDialogDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnAboutClick)
	ON_BN_CLICKED(ID_OK, OnOk)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COpenGLDialogDlg Nachrichten-Handler

BOOL COpenGLDialogDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Symbol fr dieses Dialogfeld festlegen. Wird automatisch erledigt
	//  wenn das Hauptfenster der Anwendung kein Dialogfeld ist
	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden
	

	/****
	 * create opengl controls using a for loop
	 *  this makes adding more controls easy...
	 *****/
	
	CRect rect;

	for (int i = 0; i < NUM_CONTROLS; ++i)
	{
		//beginning @ IDC_OPENGL_WINDOW1, we just have to add
		//i to get the current item..
		GetDlgItem(IDC_OPENGL_WINDOW1 + i)->GetWindowRect(rect);

		ScreenToClient(rect);

		//finally create
		openGLControls[i].Create(rect,this);
	}

	
	/***
	 * setup thread to run worker function and
	 * give pointer to the glcontrols array as parameter
	 ***/

	AfxBeginThread(ThreadWorker, (LPVOID)this);

	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}

// Wollen Sie Ihrem Dialogfeld eine Schaltflche "Minimieren" hinzufgen, bentigen Sie 
//  den nachstehenden Code, um das Symbol zu zeichnen. Fr MFC-Anwendungen, die das 
//  Dokument/Ansicht-Modell verwenden, wird dies automatisch fr Sie erledigt.

void COpenGLDialogDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext fr Zeichnen

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Symbol in Client-Rechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// Die Systemaufrufe fragen den Cursorform ab, die angezeigt werden soll, whrend der Benutzer
//  das zum Symbol verkleinerte Fenster mit der Maus zieht.
HCURSOR COpenGLDialogDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void COpenGLDialogDlg::OnAboutClick() 
{
	CAboutDlg aboutBox;

	aboutBox.DoModal();
}

void COpenGLDialogDlg::OnOk() 
{
	//tell the thread to destroy himself..
	threadToBeEnded = true;

	CDialog::OnOK();	
}

void COpenGLDialogDlg::OnClose() 
{
	// TODO: Code fr die Behandlungsroutine fr Nachrichten hier einfgen und/oder Standard aufrufen
	

	CDialog::OnClose();
}

UINT COpenGLDialogDlg::ThreadWorker(LPVOID param)
{
	/***
	 * the param value is in fact the pointer to the
	 * array of opengl controls. So we can simply do what
	 * want with it here, i.e. repaint it...
	 ***/
	
	COpenGLControl* array = ((COpenGLDialogDlg*)param)->openGLControls;
	CPoint mousePos;

	//as we're in a thread, we can do that...
	for (;;)
	{
		//don't bomb the paint loop
		Sleep(10);

		/**
		 * get the current mouse position
		   and pass it to the opengl control
		   - for smiley look calculation ;-)
		   **/
		
		GetCursorPos(&mousePos);
		((COpenGLDialogDlg*)param)->ScreenToClient(&mousePos);

		for (int i = 0; i < NUM_CONTROLS; ++i)
		{
			//send new mouse position
			array[i].UpdateMousePosition(mousePos.x, mousePos.y);

			//make current control repaint..
			array[i].InvalidateRect(NULL);
			array[i].UpdateWindow();
		}

		//check whether we want to close thread (and dialog)
		if (((COpenGLDialogDlg*)param)->threadToBeEnded)
		{
			AfxEndThread(0, TRUE);
		}
	}
}
