// SSmileyCube.cpp: Implementierung der Klasse SSmileyCube.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "SSmileyCube.h"
#include <GL/gl.h>
#include <iostream.h>

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

const float FRONT_COLOR[] = { 1.0f, 1.0f, 0.0f };
const float SIDE_COLOR[] = { 0.75f, 0.75f, 0.0f };

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

SSmileyCube::SSmileyCube()
{
	rotation[0] = rotation[1] = 0.0f;
}

SSmileyCube::~SSmileyCube()
{

}

void SSmileyCube::draw()
{
	glPushMatrix();

	/****
	 * drawing function
	 *****/

	//look at the mouse cursor
	gluLookAt(0.0f, 0.0f, 0.0f,
			mousePosition[0], -mousePosition[1], -10.0f,
			0.0f,1.0f,0.0f);

	glEnable(GL_TEXTURE_2D);

	texture.select();

	glBegin(GL_QUADS);
		// Front Face
		glColor3fv(FRONT_COLOR);
		glTexCoord2f(0.0f, 0.0f); glVertex3f(-1.0f, -1.0f,  1.0f);	// Point 1 (Front)
		glTexCoord2f(1.0f, 0.0f); glVertex3f( 1.0f, -1.0f,  1.0f);	// Point 2 (Front)
		glTexCoord2f(1.0f, 1.0f); glVertex3f( 1.0f,  1.0f,  1.0f);	// Point 3 (Front)
		glTexCoord2f(0.0f, 1.0f); glVertex3f(-1.0f,  1.0f,  1.0f);	// Point 4 (Front)

		// Back Face
		glColor3fv(SIDE_COLOR);
		glVertex3f(-1.0f, -1.0f, -1.0f);	// Point 1 (Back)
		glVertex3f(-1.0f,  1.0f, -1.0f);	// Point 2 (Back)
		glVertex3f( 1.0f,  1.0f, -1.0f);	// Point 3 (Back)
		glVertex3f( 1.0f, -1.0f, -1.0f);	// Point 4 (Back)

		// Top Face
		glVertex3f(-1.0f,  1.0f, -1.0f);	// Point 1 (Top)
		glVertex3f(-1.0f,  1.0f,  1.0f);	// Point 2 (Top)
		glVertex3f( 1.0f,  1.0f,  1.0f);	// Point 3 (Top)
		glVertex3f( 1.0f,  1.0f, -1.0f);	// Point 4 (Top)

		// Bottom Face
		glVertex3f(-1.0f, -1.0f, -1.0f);	// Point 1 (Bottom)
		glVertex3f( 1.0f, -1.0f, -1.0f);	// Point 2 (Bottom)
		glVertex3f( 1.0f, -1.0f,  1.0f);	// Point 3 (Bottom)
		glVertex3f(-1.0f, -1.0f,  1.0f);	// Point 4 (Bottom)

		// Right face
		glVertex3f( 1.0f, -1.0f, -1.0f);	// Point 1 (Right)
		glVertex3f( 1.0f,  1.0f, -1.0f);	// Point 2 (Right)
		glVertex3f( 1.0f,  1.0f,  1.0f);	// Point 3 (Right)
		glVertex3f( 1.0f, -1.0f,  1.0f);	// Point 4 (Right)

		// Left Face
		glVertex3f(-1.0f, -1.0f, -1.0f);	// Point 1 (Left)
		glVertex3f(-1.0f, -1.0f,  1.0f);	// Point 2 (Left)
		glVertex3f(-1.0f,  1.0f,  1.0f);	// Point 3 (Left)
		glVertex3f(-1.0f,  1.0f, -1.0f);	// Point 4 (Left)

	glEnd();

	glDisable(GL_TEXTURE_2D);

	glPopMatrix();
}

void SSmileyCube::create(SVector vecCenter)
{
	SSmileyCube::vecCenter = vecCenter;

	//load texture
	texture.createMipmap("data/smiley.bmp");
}

void SSmileyCube::updateMousePosition(int mouseX, int mouseY, int width, int height)
{
	/**
	 * calculate mouse position to be relative to the
	 current coordinate system.. as a projective 
	 projection isn't quite easy to measure, we use
	 try and error values... i know that's not the fine 
	 way.. but i'm _not_ sorry for that ;-) 
	 **/

	float THIS_WIDTH, THIS_HEIGHT;
	THIS_WIDTH = THIS_HEIGHT = 1.50f;
	


	//adapt to current scale..
	//  another important point is to transform the mouse position
	//  to a position relative to the center of the current object space..
	mousePosition[0] = float(mouseX-vecCenter.getX()) * (THIS_WIDTH/width);
	mousePosition[1] = float(mouseY-vecCenter.getY()) * (THIS_HEIGHT/height);
}